<template>
  <div class="client-container">
    <b-navbar
      toggleable="lg"
      type="dark"
      variant="info"
      class="client-container__header"
    >
      <b-navbar-brand href="#">
        <img
          src="./../../assets/ahasoft.png"
          class="client-container__header__img"
        />
      </b-navbar-brand>
      <b-navbar-nav>
        <b-button pill variant="primary" @click="handleSignOut"
          >Sign out</b-button
        >
      </b-navbar-nav>
    </b-navbar>
    <b-container fluid class="client-container__content">
      <b-row class="client-container__content__title">
        <b-col cols="4" class="client-title">Clients</b-col>
        <b-col cols="8" class="client-btn">
          <b-button
            variant="primary ml-1 mr-1"
            class="client-btn__add-client-btn"
            @click="handleAddClient"
            >Add Client</b-button
          >
          <b-button
            variant="primary  ml-1 mr-1"
            class="client-btn__export-btn"
            @click="exportToExcel"
            >Export</b-button
          >
        </b-col>
      </b-row>
      <!-- <br/> -->
      <b-row class="client-container__content__table">
        <b-col>
          <b-row>
            <b-col>Total {{ items.length }} client(s) searched</b-col>
          </b-row>
          <b-row>
            <b-col>
              <b-table
                bordered
                outlined
                small
                :items="items"
                :fields="fields"
                responsive
                class="client-title"
              >
                <template #cell(edit)="data">
                  <b-button
                    variant="outline-primary"
                    @click="openEditClientModal(data)"
                    ><b-icon icon="arrow-right" aria-hidden="true"></b-icon
                  ></b-button>
                </template>
                <template #cell(sales)="data">
                  <b-button
                    variant="outline-primary"
                    @click="handleEditDemo(data)"
                    ><b-icon icon="arrow-right" aria-hidden="true"></b-icon
                  ></b-button>
                </template>
                <template #cell(total_sales)="data">
                  <span>{{ formatMoney(data.item.totalSalesAmount) }}</span>
                </template>
                <template #cell(notes)="data">
                  <span v-b-tooltip.hover :title="data.item.notes">{{
                    formatText(data.item.notes)
                  }}</span>
                </template>
                <template #cell(mobile_phone)="data">
                  <span v-html="data.item.mobilePhone" />
                </template>
                <template #cell(client_name)="data">
                  <span v-b-tooltip.hover :title="data.item.clientName">{{
                    formatText(data.item.clientName)
                  }}</span>
                </template>
              </b-table>
            </b-col>
          </b-row>
          <b-row>
            <b-col class="client-table">
              <span> Page {{ pageNumber }} of {{ numOfPagination }} </span>
              <a
                class="client-table__first-page-btn"
                v-on:click="goToFirstPage"
              >
                <b-icon icon="chevron-double-left"></b-icon>
              </a>
              <a
                class="client-table__prev-page-btn"
                v-on:click="handleChangeToPrevious"
              >
                <b-icon icon="chevron-left"></b-icon>
              </a>
              <a
                class="client-table__next-page-btn"
                v-on:click="handleChangeToNext"
              >
                <b-icon icon="chevron-right"></b-icon>
              </a>
              <a
                class="client-table__final-page-btn"
                v-on:click="handleChangeToEnd"
              >
                <b-icon icon="chevron-double-right"></b-icon>
              </a>
              <a class="client-table__goto-btn" @click="handleHiddenGoto"
                >Goto</a
              >
              <div class="client-table__select" :hidden="hiddenGoto">
                <select
                  class="form-control form-control-sm"
                  v-model="pageNumber"
                  @change="handleChangeSelect"
                >
                  <option
                    v-for="(page, index) in pagination_list"
                    :key="index"
                    :value="page"
                  >
                    {{ page }}
                  </option>
                </select>
              </div>
            </b-col>
          </b-row>
        </b-col>
      </b-row>
    </b-container>
    <CustomModal
      ref="CustomModal"
      modalSize="lg"
      :is-edit-client="isEditClient"
      @get-client-info="getClientInfo"
    />
  </div>
</template>

<script>
import * as api from "./../../apis/api";
import "./ClientPage.scss";
import CustomModal from "./../CustomModal/CustomModal.vue";
import * as constant from "../../libs/Constant.js";
import Swal from "sweetalert2";
const Excel = require("exceljs");
import FileSaver from "file-saver";
export default {
  name: "ClientPage",
  props: {
    msg: String,
  },
  components: {
    CustomModal,
  },
  data() {
    return {
      constant,
      fields: [
        {
          key: "registered_date",
          label: "Registered Date",
          thStyle: {
            fontWeight: "normal",
            verticalAlign: "middle",
            backgroundColor: "#edf0f0",
          },
        },
        {
          key: "client_name",
          label: "Client Name",
          thStyle: {
            fontWeight: "normal",
            verticalAlign: "middle",
            backgroundColor: "#edf0f0",
          },
        },
        {
          key: "mobile_phone",
          label: "Mobile / Phone",
          thStyle: {
            fontWeight: "normal",
            verticalAlign: "middle",
            backgroundColor: "#edf0f0",
          },
        },
        {
          key: "total_sales",
          label: "Total Sales",
          thStyle: {
            fontWeight: "normal",
            verticalAlign: "middle",
            backgroundColor: "#edf0f0",
          },
        },
        {
          key: "notes",
          label: "Notes",
          thStyle: {
            fontWeight: "normal",
            verticalAlign: "middle",
            backgroundColor: "#edf0f0",
          },
        },
        {
          key: "edit",
          label: "Edit",
          thStyle: {
            fontWeight: "normal",
            verticalAlign: "middle",
            backgroundColor: "#edf0f0",
          },
        },
        {
          key: "sales",
          label: "Sales",
          thStyle: {
            fontWeight: "normal",
            verticalAlign: "middle",
            backgroundColor: "#edf0f0",
          },
        },
      ],
      items: [],
      pageSize: 10,
      pageNumber: 1,
      totalItems: -1,
      numOfPagination: -1,
      hiddenGoto: true,
      isEditClient: false,
    };
  },
  methods: {
    setEditClient(flag) {
      return new Promise((resolve, reject) => {
        try {
          this.isEditClient = flag;
          resolve();
        } catch (e) {
          reject(e);
        }
      });
    },
    async openEditClientModal(data) {
      // this.isEditClient = true;
      await this.setEditClient(true);
      this.$refs.CustomModal.openModal(data);
    },
    handleSignOut() {
      Swal.fire({
        title: "Are you sure?",
        text: "You want to logout to client page, don't you?",
        icon: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3499db",
        cancelButtonColor: "#38bae6",
        confirmButtonText: "Logout",
      }).then((result) => {
        if (result.isConfirmed) {
          sessionStorage.clear();
          this.$router.push("/");
        }
      });
    },
    async getClientInfo() {
      var client_info_api = await api.postAPIs(constant.CLIENT_API, {
        pageSize: this.pageSize,
        pageNumber: this.pageNumber,
        shopId: this.shopId,
      });
      if (client_info_api.status === 200 && client_info_api?.data?.result) {
        this.totalItems = client_info_api.data.result.pagingInfo.totalItems;
        this.numOfPagination = Math.ceil(this.totalItems / this.pageSize);
        var items = client_info_api.data.result.items;
        this.items.length = 0;
        for (var i = 0; i < items.length; i++) {
          // console.log("items[i] = ", items[i]);
          var mobilePhone;
          if (items[i].phoneNumber && items[i].mobileNumber)
            mobilePhone =
              this.formatPhoneNumber(items[i].phoneNumber) +
              "<br>/" +
              this.formatPhoneNumber(items[i].mobileNumber);
          else if (items[i].phoneNumber && !items[i].mobileNumber)
            mobilePhone = this.formatPhoneNumber(items[i].phoneNumber);
          else if (!items[i].phoneNumber && items[i].mobileNumber)
            mobilePhone = this.formatPhoneNumber(items[i].mobileNumber);
          else mobilePhone = "";
          let registeredDate = items[i].modificationDate
            .split("T")[0]
            .split("-");

          this.items.push({
            registered_date:
              registeredDate[0] +
              "-" +
              constant.MONTH[Number(registeredDate[1])] +
              "-" +
              registeredDate[2],
            clientName: items[i].clientName,
            clientId: items[i].clientId,
            memberNumber: items[i].memberNumber,
            mobilePhone: mobilePhone,
            mobileNumber: items[i].mobileNumber,
            phoneNumber: items[i].phoneNumber,
            totalSalesAmount: items[i].totalSalesAmount,
            notes: items[i].notes,
          });
        }
      } else {
        this.handleSignOut();
      }
    },
    async goToFirstPage() {
      this.pageNumber = 1;
      await this.getClientInfo();
    },
    async handleChangeToPrevious() {
      if (this.pageNumber > 1) {
        this.pageNumber = this.pageNumber - 1;
        await this.getClientInfo();
      }
    },
    async handleChangeToNext() {
      if (this.pageNumber < this.numOfPagination) {
        this.pageNumber = this.pageNumber + 1;
        await this.getClientInfo();
      }
    },
    async handleChangeToEnd() {
      this.pageNumber = this.numOfPagination;
      await this.getClientInfo();
    },
    handleChangeSelect() {
      this.getClientInfo();
    },
    handleHiddenGoto() {
      this.hiddenGoto = !this.hiddenGoto;
    },
    formatPhoneNumber(phoneNumberString) {
      var cleaned = ("" + phoneNumberString).replace(/\D/g, "");
      var match = cleaned.match(/^(\d{3})(\d{3})(\d{4})$/);
      if (match) {
        return match[1] + "-" + match[2] + "-" + match[3];
      }
      return null;
    },
    formatText(str) {
      if (str && str.length > 20) return str.substring(0, 20) + " ...";
      else if (str && str.length <= 20) return str;
      else return "";
    },
    formatMoney(money) {
      return new Intl.NumberFormat().format(money);
    },
    async handleAddClient() {
      await this.setEditClient(false);
      this.$refs.CustomModal.openModal();
    },
    async exportToExcel() {
      const workbook = new Excel.Workbook();
      const worksheet = workbook.addWorksheet("Client List Page 2", {
        pageSetup: { paperSize: 20, orientation: "landscape" },
      });

      worksheet.mergeCells("B2:D3");
      worksheet.getCell("B2").value = "Client List";
      worksheet.getCell("B2").font = {
        size: 20,
        bold: true,
      };
      worksheet.getCell("B2").alignment = {
        vertical: "middle",
        horizontal: "center",
      };

      worksheet.getRow(5).values = [
        "Client No",
        "Client Name",
        "Mobile",
        "Total Sales",
        "Note",
      ];

      worksheet.columns = [
        { key: "clientNumber", width: 10 },
        { key: "clientName", width: 50 },
        { key: "mobile", width: 25 },
        { key: "totalSales", width: 25 },
        { key: "notes", width: 50 },
      ];

      var arrData = [];
      this.items.forEach((item) => {
        let mobileExport = "";
        if (!item.mobileNumber && !item.phoneNumber) {
          mobileExport = "";
        } else if (!item.mobileNumber && item.phoneNumber) {
          mobileExport = this.formatPhoneNumber(item.phoneNumber);
        } else if (item.mobileNumber && !item.phoneNumber) {
          mobileExport = this.formatPhoneNumber(item.mobileNumber);
        } else {
          mobileExport =
            this.formatPhoneNumber(item.phoneNumber) +
            " / " +
            this.formatPhoneNumber(item.mobileNumber);
        }
        arrData.push({
          clientNumber: item.memberNumber,
          clientName: item.clientName,
          mobile: mobileExport,
          totalSales: this.formatMoney(item.totalSalesAmount),
          notes: item.notes,
        });
      });

      arrData.forEach(function (item) {
        worksheet.addRow({
          clientNumber: item.clientNumber,
          clientName: item.clientName,
          mobile: item.mobile,
          totalSales: item.totalSales,
          notes: item.notes ? item.notes : "",
        });
      });
      for (var i = 5; i <= 5 + arrData.length; i++) {
        worksheet.getRow(i)._cells.forEach((cell) => {
          worksheet.getCell(cell._address).border = {
            top: { style: "thin" },
            left: { style: "thin" },
            bottom: { style: "thin" },
            right: { style: "thin" },
          };
        });
      }

      var timeNow = new Date();

      workbook.xlsx
        .writeBuffer()
        .then((buffer) =>
          FileSaver.saveAs(
            new Blob([buffer]),
            `${timeNow.getDate()}-${
              constant.MONTH[timeNow.getMonth() + 1]
            }-${timeNow.getFullYear()}_${timeNow.getHours()}H${timeNow.getMinutes()}M_client-information.xlsx`
          )
        )
        .catch();
    },
  },
  async mounted() {
    var token = sessionStorage.getItem("token");
    var shopId = sessionStorage.getItem("shopId");
    if (token && shopId) {
      this.authToken = token;
      this.shopId = shopId;
      await this.getClientInfo();
    } else {
      sessionStorage.clear();
      this.$router.push("/");
    }
  },
  computed: {
    pagination_list() {
      var list_page = [];
      for (var i = 1; i <= this.numOfPagination; i++) {
        list_page.push(i);
      }
      return list_page;
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" scoped>
</style>
